﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Private btnnext As Button
	Private btnprev As Button
	Private btnsearch As Button
	Private lblpages As Label
	Private lblzoom As Label
	Private sp1 As ScrollPane
	Private wv1 As WebView
	Private cbx1 As B4XComboBox
	Private cbx2 As B4XComboBox
	Private clv1 As CustomListView
	Private clv2 As CustomListView
	Private clv3 As CustomListView
	Private ftfsearch As B4XFloatTextField
	Private btncsv As Button
	Private btngrid As Button
	Private btnhtml As Button
	Private btnjson As Button
	Private btnload As Button
	Public exportfolder As String
	Public importfolder As String
	Public reclst As List
	Public numrows As Int
	Public numcols As Int
	Public clvpane As Pane
	Public clvpane2 As Pane
	Private fchoose As FileChooser
	Private filename As String
	Private delim As String
	Public page As Int
	Public numpages As Int
	Public startindex As Int
	Public endindex As Int
	Public searchlst As List
	Private cbxdelim As B4XComboBox
	Public infodialog As B4XDialog
	Private clvinfo As CustomListView
	Private lbltitle As Label
	Private lblhint As Label
	Private ta1 As TextArea
	Public maxcols As Int
	Public htmlstring As String
	Private lblzoom As Label
	Public rowclr1, rowclr2, cbx1clr, cbx2clr, cbxdelimclr As Paint

End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"CSV Viewer")
	Dim jo As JavaObject = wv1
	Dim e As Object = jo.CreateEventFromUI("javafx.event.EventHandler", "scroll", Null)
	jo.RunMethod("setOnScroll", Array(e))
	xui.SetDataFolder("csv_viewer")
	File.MakeDir(xui.DefaultFolder,"Export")
	File.MakeDir(xui.DefaultFolder,"Import")
	exportfolder = File.DirData("csv_viewer") & "\Export"
	importfolder = File.DirData("csv_viewer") & "\Import"
	fchoose.Initialize
	searchlst.Initialize
End Sub
Private Sub B4XPage_Appear
	wv1.Visible = False
	lblzoom.Text = ""
	set_colors
	maxcols = 1
	Dim cbxlst As List = Array As Int(5,10,15,20,25,30,50,100)
	cbx1.SetItems(cbxlst)
	Dim delimlst As List = Array As String(";",",","=",":")
	cbxdelim.SetItems(delimlst)
	fill_cbx2
	reclst.Initialize
	filename = cbx2.SelectedItem
	If filename <> "" Then
		fill_grid
	End If
End Sub
Private Sub fill_cbx2
	Private lst As List = File.ListFiles(importfolder)
	cbx2.SetItems(lst)
End Sub
Private Sub fill_grid
	filename = cbx2.SelectedItem
	If filename <> "" Then
		B4XPages.SetTitle(Me,"CSV Viewer - " & filename)
	Else
		Return
	End If
	lblpages.Text = "Loading..."
	Sleep(10)
	delim = cbxdelim.SelectedItem
	fill_reclst
	clvpane.Initialize("")
	clvpane2.Initialize("")
	page = 1
	startindex = 1
	endindex = startindex + cbx1.SelectedItem-1
	fill_clv3
	fill_clv1
	clvpane.AddNode(clv3.sv,0dip,0dip,clv3.sv.Width,clv3.sv.Height)
	clvpane2.AddNode(clv1.sv,0dip,0dip,clv1.sv.Width,clv1.sv.Height)
	clvpane.SetLayoutAnimated(0,0dip,0dip,clv1.sv.Width,clv1.sv.Height)
	clvpane2.SetLayoutAnimated(0,0dip,0dip,clv1.sv.Width,clv1.sv.Height)
	Dim pn As Pane
	pn.Initialize("")
	pn.AddNode(clvpane,0dip,0dip,clv3.sv.Width,clv3.sv.Height)
	pn.AddNode(clvpane2,0dip,70dip,clv1.sv.Width,clv1.sv.Height)
	pn.SetLayoutAnimated(0,0dip,0dip,clv3.sv.Width,clv3.sv.Height+70dip)
	sp1.InnerNode = pn
	sp1.InnerNode.Style = "-fx-background-color: #E2DFFF;-fx-font-size: 15;"
	fill_clv2
	set_numpages
End Sub
private Sub add_row_numbers
	maxcols = 1
	Dim rec As String = reclst.Get(0)
	If rec.StartsWith("0") Then Return
	For i = 0 To reclst.Size -1
		Dim rrec As String = reclst.get(i)
		Dim cols() As String = Regex.Split(delim,rrec)
		If cols.Length > maxcols Then
			maxcols = cols.Length
		End If
		rrec = i & delim & rrec
		reclst.RemoveAt(i)
		reclst.InsertAt(i,rrec)
	Next
End Sub
Private Sub set_numpages
	numpages = Floor(numrows/cbx1.SelectedItem)
	If (numpages*cbx1.SelectedItem) = numrows-1 Then
		If numpages <= 1 Then
			numpages = 1
		Else
			numpages = numpages
		End If
	Else
		numpages = numpages + 1
	End If
	lblpages.Text = page & " / " & numpages & CRLF & "rows: " & numrows & " cols: " & numcols
End Sub
Private Sub fill_reclst
	reclst.Clear
	Dim recstr As String = File.ReadString(importfolder,cbx2.SelectedItem)
	If recstr.Contains(Chr(13)) Then
		recstr = recstr.Replace(Chr(10),"")		' take out the linefeeds from inside the cells
		'Log(recstr)
		Dim rows() As String = Regex.Split(Chr(13),recstr)
		For i = 0 To rows.Length -1
			reclst.Add(rows(i))
		Next
	Else
		reclst = File.ReadList(importfolder,cbx2.SelectedItem)
		Dim rowzero As String = reclst.Get(0)
		If rowzero.Contains("sep=") Then
			delim = rowzero.SubString(rowzero.Length-1)
			cbxdelim.SelectedIndex = cbxdelim.IndexOf(delim)		
			reclst.RemoveAt(0)
		End If
	End If
	numrows = reclst.Size
	add_row_numbers
End Sub
private Sub fill_clv3
	clv3.Clear
	Dim rec As String = reclst.get(0)
	Dim columns() As String = Regex.Split(delim,rec)
	numcols = columns.Length
	rec = rec.SubString(rec.IndexOf(delim)+1)		' not show the first column
	Dim pnl As Pane = set_item(rec,0,"lblhead")
	clv3.Add(pnl,rec)
	'Log(numcols)
	'Log(maxcols)
	If maxcols > numcols Then numcols = maxcols+1
	'Log(numcols)
	clv3.AsView.Width = ((numcols-1)*200dip)+50dip
	clv3.sv.Width = ((numcols-1)*200dip)+50dip
End Sub
private Sub fill_clv1
	clv1.Clear
	If endindex >= numrows-1 Then endindex = numrows-1
	For i = startindex To endindex
		Dim rec As String = reclst.Get(i)
		'Log(rec)
		rec = rec.SubString(rec.IndexOf(delim)+1)	' not show the first column
		If searchlst.Size > 0 And searchlst.IndexOf(i) <> -1 Then
			rowclr1 = fx.Colors.From32Bit(0xFF00FF03)
			rowclr2 = fx.Colors.From32Bit(0xFF00FF03)
		Else
			rowclr1 = fx.Colors.From32Bit(0xFFFFFFFF)
			rowclr2 = fx.Colors.From32Bit(0xFFE2DFFF)
		End If
		Dim pnl As Pane = set_item(rec,i,"")
		clv1.Add(pnl,rec)
		rowclr1 = fx.Colors.From32Bit(0xFFFFFFFF)
		rowclr2 = fx.Colors.From32Bit(0xFFE2DFFF)
	Next
	clv1.AsView.Width = ((numcols-1)*200dip)+50dip
	clv1.sv.Width = ((numcols-1)*200dip)+50dip
End Sub
private Sub fill_clv2
	clv2.Clear
	Dim rec As String
	If endindex >= numrows-1 Then endindex = numrows-1
	For i = startindex To endindex
		rec = reclst.Get(i)
		Dim fields() As String = Regex.Split(delim,rec)
		Dim pnl As Pane = set_item(rec,i,"")
		clv2.Add(pnl,fields(0))
	Next
	clv2.AsView.Width = 1*60dip
	clv2.sv.Width = 1*60dip
End Sub
Private Sub set_item(rec As String, irow As Int,event As String) As Pane
	'Log(rec)
	Dim columns() As String = Regex.Split(delim,rec)
	Dim pnl As Pane
	pnl.Initialize("")
	For x = 0 To columns.Length-1
		Dim lbl As Label
		lbl.Initialize(event)
		lbl.Tag = irow & delim & x
		lbl.Text = columns(x)
		If irow Mod 2 <> 0 Then
			CSSUtils.SetBackgroundColor(lbl,rowclr1)
		Else
			CSSUtils.SetBackgroundColor(lbl,rowclr2)
		End If
		CSSUtils.SetBorder(lbl,1,fx.Colors.Black,3)
		CSSUtils.SetStyleProperty(lbl,"-fx-wrap-text","TRUE")		'FALSE
		CSSUtils.SetStyleProperty(lbl,"-fx-alignment","TOP_LEFT")	'CENTER_LEFT
		CSSUtils.SetStyleProperty(lbl,"-fx-padding","0 0 0 5")		'top-right-bottom-left
		pnl.AddNode(lbl,0dip+(x*200dip),0dip,200dip,60dip)
	Next
	pnl.SetLayoutAnimated(0,0dip,0dip,(x+1)*200dip,60dip)
	Return pnl
End Sub
Private Sub set_colors
	rowclr1 = fx.Colors.From32Bit(0xFFE2DFFF)
	rowclr2 = fx.Colors.From32Bit(0xFFFFFFFF)
	cbx1clr = fx.Colors.From32Bit(0xFFCCC8F9)
	cbx2clr = fx.Colors.From32Bit(0xFFCCC8F9)
	cbxdelimclr = fx.Colors.From32Bit(0xFFCCC8F9)
	' buttons see Files Manager - stylesheet: styles.css
	cbx1.cmbBox.Style = "-fx-background-color: #CCC8F9;-fx-border-color: #000000;-fx-border-width: 2;-fx-border-radius: 3;"
	cbx2.cmbBox.Style = "-fx-background-color: #CCC8F9;-fx-border-color: #000000;-fx-border-width: 2;-fx-border-radius: 2;"
	cbxdelim.cmbBox.Style = "-fx-background-color: #CCC8F9;-fx-border-color: #000000;-fx-border-width: 2;-fx-border-radius: 2;"
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	infodialog.Initialize(Root)
	infodialog.PutAtTop = True
	infodialog.BackgroundColor = xui.Color_ARGB(100,255,255,255)
	show_infodialog(Index,Value)
End Sub
Private Sub clv2_ItemClick (Index As Int, Value As Object)
	infodialog.Initialize(Root)
	infodialog.PutAtTop = True
	infodialog.BackgroundColor = xui.Color_ARGB(100,255,255,255)
	show_infodialog(Index,Value)
End Sub
Private Sub clv3_ItemClick (Index As Int, Value As Object)
	' sorting
End Sub
Private Sub clv2_ScrollChanged (Offset As Int)
	clv1.sv.ScrollViewOffsetY = Offset
End Sub
Private Sub clv1_ScrollChanged (Offset As Int)
	clv2.sv.ScrollViewOffsetY = Offset
End Sub
Private Sub cbx2_SelectedIndexChanged (Index As Int)
	wv1.Visible = False
	lblzoom.Text = ""
	fill_grid
End Sub
Private Sub cbxdelim_SelectedIndexChanged (Index As Int)
	fill_grid
End Sub
Private Sub cbx1_SelectedIndexChanged (Index As Int)
	page = 1
	startindex = 1
	endindex = startindex + cbx1.SelectedItem-1
	set_numpages
	fill_clv3
	fill_clv1
	fill_clv2
End Sub
Private Sub btnprev_Click
	startindex = startindex-cbx1.SelectedItem
	endindex = startindex + cbx1.SelectedItem-1
	If startindex < 1 Then
		page = 1
		startindex = 1
		endindex = startindex + cbx1.SelectedItem-1
		set_numpages
		fill_clv3
		fill_clv1
		fill_clv2
	Else
		page = page - 1
		set_numpages
		fill_clv3
		fill_clv1
		fill_clv2
	End If
End Sub
Private Sub btnnext_Click
	startindex = endindex+1
	endindex = startindex + cbx1.SelectedItem-1
	If endindex > numrows And numrows - startindex < 1 Then
		page = 1
		startindex = 1
		endindex = startindex + cbx1.SelectedItem-1
		set_numpages
		fill_clv3
		fill_clv1
		fill_clv2
	Else
		page = page + 1
		set_numpages
		fill_clv3
		fill_clv1
		fill_clv2
	End If
End Sub
Private Sub btngrid_Click
	wv1.Visible = False
	lblzoom.Text = ""
	fill_grid
End Sub
Private Sub btnsearch_Click
	If ftfsearch.Text = "" Then
		Return
	End If
	Dim strtext As String = htmlstring
	Dim uptext As String = strtext.ToUpperCase
	If wv1.Visible = True And uptext.Contains(ftfsearch.Text.ToUpperCase) Then
		uptext = uptext.Replace(ftfsearch.Text.ToUpperCase,"<span class='w3-red'>" & ftfsearch.Text.ToUpperCase & "</span>")
		strtext = uptext.ToLowerCase
		wv1.LoadHtml(strtext)
		'Log(strtext)
		Return
	End If
	searchlst.Initialize
	Dim is_found As Boolean = False
	For i = 0 To reclst.Size - 1
		Dim rec As String = reclst.Get(i)
		Dim orec As String = rec
		rec = rec.ToUpperCase
		If rec.Contains(ftfsearch.Text.ToUpperCase) Then
			searchlst.Add(orec)
			is_found = True
		End If
	Next
	If is_found = True Then
		If searchlst.Size > 0 Then
			searchlst.InsertAt(0,reclst.Get(0))
			reclst.Clear
			For i = 0 To searchlst.Size -1
				reclst.Add(searchlst.Get(i))
			Next
			numrows = reclst.Size
			page = 1
			startindex = 1
			endindex = startindex + cbx1.SelectedItem-1
			set_numpages
			fill_clv3
			fill_clv1
			fill_clv2
		End If
	Else
		xui.MsgboxAsync("There were no matches found.","Find")
	End If
End Sub
Private Sub ftfsearch_EnterPressed
	btnsearch_Click
End Sub
Private Sub btnload_Click
	Dim fname As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If fname.EndsWith(".csv") Then
		'Log(fname)
		Dim path As String = fname.SubString2(0,fname.LastIndexOf("\")+1)
		filename = fname.SubString(fname.LastIndexOf("\")+1)
		File.Copy(path,filename,importfolder,filename)
		fill_cbx2
		Return
	Else
		filename = ""
		xui.MsgboxAsync("No CSV file selected","Open file")
		Return
	End If
End Sub
Private Sub btnjson_Click
	Dim outer As List
	outer.Initialize
	Dim inner As List
	inner.Initialize
	Dim rec As String
	rec = reclst.Get(0)
	rec = rec.Replace("[","")
	rec = rec.Replace("]","")
	Dim newrec As String
	Dim lst As List = Regex.Split(delim,rec)
	For i = 0 To lst.Size -1
		Dim fld As String = lst.get(i)
		If IsNumber(fld) Then
			newrec = newrec & fld & delim
		Else
			newrec = newrec & """" & fld.Trim & """" & delim
		End If
	Next
	rec= newrec.SubString2(0,newrec.Length-1)
	rec = "[" & rec & "]"
	inner.Add(rec)
	For i = 1 To reclst.Size -1
		Dim rec As String = reclst.Get(i)
		Dim newrec As String
		Dim lst As List = Regex.Split(delim,rec)
		For j = 0 To lst.Size -1
			Dim fld As String = lst.get(j)
			If IsNumber(fld) Then
				newrec = newrec & fld & delim
			Else
				newrec = newrec & """" & fld.Trim & """" & delim
			End If
		Next
		rec= newrec.SubString2(0,newrec.Length-1)
		rec = "[" & rec & "]"
		inner.Add(rec)
	Next
	outer.Add(inner)
	'Log(outer)
	Dim fname As String = filename.SubString2(0,filename.LastIndexOf("."))
	fname = fname & "_export.json"
	File.Delete(exportfolder,fname)
	File.Writelist(exportfolder,fname,outer)
	xui.MsgboxAsync(fname & " is saved in the export folder.","Save JSON")
End Sub
Private Sub btncsv_Click
	'Log(reclst)
	Dim rec As String = reclst.Get(0)
	rec = rec.Replace("[","")
	rec = rec.Replace("]","")
	rec = "sep=" & delim  & CRLF & rec			' set the separator in the file
	reclst.RemoveAt(0)
	reclst.InsertAt(0,rec)
	Dim fname As String = filename.SubString2(0,filename.LastIndexOf("."))
	fname = fname & "_export.csv"
	File.Delete(exportfolder,fname)
	File.Writelist(exportfolder,fname,reclst)
	xui.MsgboxAsync(fname & " is saved in the export folder.","Save CSV")
End Sub
Private Sub show_infodialog(index As Int, irec As String)
	Log(index)
	Log(irec)
	If irec.Contains(delim) = False Then
		irec = reclst.Get(irec)
		irec = irec.SubString(irec.IndexOf(delim)+1)
	End If
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 800dip, 560dip)
	pnl.LoadLayout("info_layout")
	lbltitle.Text = "Information " & (index+1)
	Dim rec As String = reclst.get(0)
	rec = rec.SubString(rec.IndexOf(delim)+1)
	Dim columns() As String = Regex.Split(delim,rec)
	'Log(columns.Length)
	For i = 0 To columns.Length - 1
		Dim p As B4XView = xui.CreatePanel("p")
		p.SetLayoutAnimated(0,0dip,10dip,800dip,140dip)
		p.LoadLayout("infoitem_layout")
		lblhint.Text = columns(i)
		lblhint.PrefHeight = 30dip
		Dim flds() As String = Regex.Split(delim,irec)
		If i <= flds.Length-1 Then
			ta1.Text = flds(i)
		Else
			ta1.Text = ""
		End If
		ta1.Tag = "txt_" & i
		CSSUtils.SetStyleProperty(ta1,"-fx-wrap-text","TRUE")
		CSSUtils.SetStyleProperty(ta1,"-fx-alignment","TOP_LEFT")
		CSSUtils.SetStyleProperty(ta1,"-fx-padding","0 0 0 5")		'top-right-bottom-left
		clvinfo.Add(p,"")
	Next
	Dim rsub1 As ResumableSub =  infodialog.ShowCustom(pnl, "OK", "", "")
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		'
	End If
End Sub
Private Sub btnhtml_Click
	wv1.Visible = True
	wv1.Zoom = 1.0
	lblzoom.Text = ""
	Private sb As StringBuilder
	sb.Initialize
	sb = html_header(sb)
	Dim rec As String = reclst.Get(0)
	Dim lst As List = Regex.Split(delim,rec)
	sb.Append("<table>").Append(CRLF).Append("<tr>").Append(CRLF)
	For i = 0 To lst.Size -1
		sb.Append("<th class='sticky'>").Append(lst.Get(i)).Append("</th>")
	Next
	sb.Append("</tr>").Append(CRLF)
	For i = 1 To reclst.Size - 1
		If i Mod 2 = 1 Then
			sb.Append("<tr class='odd'>").Append(CRLF)
		Else
			sb.Append("<tr>").Append(CRLF)
		End If
		Dim rec As String = reclst.Get(i)
		Dim lst As List = Regex.Split(delim,rec)
		For x = 0 To lst.Size -1
			sb.Append("<td>").Append(lst.Get(x)).Append("</td>")					
		Next
		sb.Append("</tr>").Append(CRLF)
	Next
	sb = html_footer(sb)
	htmlstring = sb.ToString
	'Log(htmlstring)
	wv1.LoadHtml(htmlstring)
	wv1.PrefWidth = sp1.InnerNode.PrefWidth + 100dip
	sp1.InnerNode = wv1
End Sub
Private Sub html_header(sb As StringBuilder) As StringBuilder
	Private HtmlCSS As String
	HtmlCSS = "table {font-family:helvetica;width: 100%;border: 1px solid #cef;text-align: left; }" _
		& " th { font-weight: bold;	background-color: #B0C4DE;	border-bottom: 1px solid #cef; }" _ 
		& "td,th {	padding: 4px 5px; }" _
		& ".odd {background-color: #def; } .odd td {border-bottom: 1px solid #cef; }" _
		& "a { text-decoration:none; color: #000; }" _
		& "th.sticky { position: -webkit-sticky; position: sticky; top:0; background-color: #B0C4DE; }"
	sb.Append("<html>")
	sb.Append("<head>")
	sb.Append("<meta name='viewport' content='width=device-width, initial-scale=1'>")
	Dim w3css As String = File.ReadString(File.DirAssets,"w3.css")
	sb.Append("<style type='text/css'>").Append(w3css).Append("</style>").Append(CRLF)
	'sb.Append("<link rel='stylesheet' href='https://www.w3schools.com/w3css/4/w3.css'>")
	sb.Append("<style type='text/css'>").Append(HtmlCSS).Append("</style>").Append(CRLF)
	sb.Append("</head><body>").Append(CRLF)
	sb.Append("<table>").Append(CRLF)
	Return sb
End Sub
Private Sub html_footer(sb As StringBuilder) As StringBuilder
	sb.Append("</table>")
	sb.Append("</body></html>")
	Return sb
End Sub
Sub Scroll_Event (MethodName As String, Args() As Object) As Object
	Dim scrollevent As JavaObject = Args(0)
	Dim bControl As Boolean = scrollevent.RunMethod("isControlDown", Null)
	If bControl Then
		Dim dTDy As Double = scrollevent.RunMethod("getTextDeltaY", Null)
		'Log(dTDy)
		If dTDy < 0 Then
			wv1.Zoom = wv1.Zoom - 0.1
		Else
			wv1.Zoom = wv1.Zoom + 0.1		
		End If
		If wv1.Zoom < 0.5 Then wv1.Zoom = 0.5
		If wv1.Zoom > 1.5 Then wv1.Zoom = 1.5
		'Log(wv1.Zoom)
		lblzoom.Text = "Zoom:" & CRLF & Round2(wv1.Zoom,1)
	End If
	Return Null
End Sub
